#
# RDE AutoComplete Data File Maker
# by sakazuki
# 
#

require 'rde'

$alone = ($0 == __FILE__)

if $alone then
  require 'cgi/session'
  require 'cgi'
  require 'complex'
#require 'curses.so'
  require 'date'
#require 'dbm'
  require 'delegate'
#require 'digest'
#require 'digest/md5'
#require 'digest/rmd160'
#require 'digest/sha1'
#require 'digest/sha2'
  require 'e2mmap'
#require 'etc'
#require 'expect'
  require 'forwardable'
#require 'gdbm'
  require 'kconv'
  require 'mailread'
  require 'matrix'
  require 'md5'
  require 'net/ftp'
  require 'net/http'
  require 'net/pop'
  require 'net/smtp'
  require 'net/telnet'
  require 'nkf'
  require 'observer'
  require 'open3'
  require 'ostruct'
  require 'parsedate'
  require 'ping'
  require 'pstore'
#require 'pty'
  require 'rational'
  require 'rbconfig'
#require 'readline'
#require 'resolv'
  require 'sdbm'
  require 'shellwords'
  require 'singleton'
  require 'socket'
  require 'sync'
  require 'tempfile'
  require 'thread'
  require 'thwait'
  require 'timeout'
  require 'weakref'
  require 'Win32API'
end

def rde_export(obj, binding)
  #b = obj.singleton_methods
  b = obj.methods
  lists = {};
  b.each{|k|
    lists[k] = 1
  }
  if obj.respond_to?("instance_methods") then
    b = obj.instance_methods(true)
    b.each{|k|
      if lists.key?(k)
        lists[k] = (lists[k] | 2)
      else
        lists[k] = 2
      end
    }
  end
  if obj.respond_to?("constants") then
    b = obj.constants - obj.superclass.constants
    b.each{|k|
      if lists.key?(k)
        lists[k] = (lists[k] | 4)
      else
        lists[k] = 4
      end
    }
  end
  if lists.size > 0 then
    if $alone then
      Dir.chdir("#{Rde.path}")
    else
      Dir.chdir("#{Rde.path}\\rde_temp")
    end
    #Dir.chdir("d:\\tools\\rdesrc\\main\\data")
    if obj.name =~ /::/ then
      subdirs = obj.name.split("::")
      begin
        subdirs[0..-2].each{|subdir|
          begin
            Dir.mkdir(subdir)
          rescue Errno::EEXIST
          ensure
            Dir.chdir("./#{subdir}")
          end
        }
      ensure
        fname = subdirs[-1]
      end
    else
      fname = obj.name
    end
    open(fname + ".dat", "w"){|f|
      lists.keys.sort.each{|k|
        f.printf "%s\t%s\t%s\n", k, k, lists[k].to_s
      }
    }
    puts "#{fname}.dat is created."
  else
    puts "#{obj.name} have no data"
  end
end #rde_export

def export_Object_private
  b = Object.private_methods | Object.constants | Object.methods
  if $alone then
    Dir.chdir("#{Rde.path}")
  else
    Dir.chdir("#{Rde.path}\\rde_temp")
  end
  open("rde_Object_private.dat", "w"){|f|
    b.sort.each{|k|
      f.printf "%s\t%s\t%s\n", k, k, 7
    }
  }
end

def do_export
  ObjectSpace.each_object(Module){|klass|
    begin
      rde_export(klass, binding)
    rescue NameError
      puts 'NameErr'
    end
  }
end

if ARGV[0] =~ /-p/ then
  export_Object_private
elsif $alone then
  do_export
end
