#! ruby
#
# simple grep.
# Usage: grep [-i] pattern file
#

require "getopts"
getopts("i", "help")
def grep(filename)
  begin
    File.open(filename, "r"){|f|
      f.each_line{|line|
        printf("%s:%d: %s\n", filename, f.lineno , line.chomp) if $re.match(line)
      }
    }
  rescue
    usage(sprintf("can't open %s: %s" ,  filename, $!))
  end
end

def main
  reflag = Regexp::IGNORECASE if $OPT_i
  if ARGV.size < 1
    usage("not enough arguments")
  elsif ARGV.size > 2
    usage("exactly one file argument required")
  end
  pattern, filename = ARGV[0..1]
  begin
    $re = Regexp.new(pattern, reflag)
  rescue
    usage(sprintf("error in regular expression(%s): %s", pattern, $!))
  end
  filename.gsub!("\\\\", "/")
  Dir.glob(filename){|file|
    grep(file)
  }
end
  
def usage(msg)
  STDERR.print msg
  exit 2
end

if $0 == __FILE__
  main
end
